﻿Public Class Form1
    Dim acc As New AcessoDados

    Private Sub btnIncluir_Click(sender As System.Object, e As System.EventArgs) Handles btnIncluir.Click
        Dim arrImage() As Byte
        Dim strImage As String
        Dim myMs As New IO.MemoryStream

        If txtNome.Text = String.Empty Then
            MsgBox("Informe o nome do aluno")
            txtNome.Focus()
            Return
        End If

        If Not IsNothing(Me.picFoto.Image) Then
            Me.picFoto.Image.Save(myMs, Me.picFoto.Image.RawFormat)
            arrImage = myMs.GetBuffer
            strImage = "?"
        Else
            arrImage = Nothing
            strImage = "NULL"
        End If

        Try
            acc.incluirDados(txtNome.Text, arrImage, strImage)
            MsgBox("Dados Salvos com sucesso!")
        Catch ex As Exception
            MsgBox("Erro ao incluir dados!")
        End Try

        CarregaDados()
    End Sub
    Private Sub btnProcurar_Click(sender As System.Object, e As System.EventArgs) Handles btnProcurar.Click
        If txtCodigo.Text = String.Empty Then
            MsgBox("Informe o codigo do aluno")
        Else
            Procurar(Me.txtCodigo.Text)
        End If
    End Sub
    Private Sub Procurar(ByVal codigo As Integer)
        Dim arrImage() As Byte = Nothing
        Dim myMS As New IO.MemoryStream
        Dim aluno1 As New Aluno

        aluno1 = acc.procurarDados(codigo)

        If Not IsNothing(aluno1) Then

            Me.txtCodigo.Text = aluno1.Codigo
            Me.txtNome.Text = aluno1.Nome
            If Not IsDBNull(aluno1.Imagem) Then
                Me.picFoto.Image = aluno1.Imagem
            Else
                Me.picFoto.Image = System.Drawing.Image.FromFile(Application.StartupPath & "/semfoto.jpg")
            End If
            Me.btnIncluir.Enabled = False
        Else
            MsgBox("Registro não localizado")
        End If

    End Sub
    Private Sub lnkProcurar_LinkClicked(sender As System.Object, e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkProcurar.LinkClicked
        If Me.ofdImagem.ShowDialog = 1 Then
            Me.picFoto.Image = System.Drawing.Image.FromFile(Me.ofdImagem.FileName)
        Else
            Me.picFoto.Image = System.Drawing.Image.FromFile(Application.StartupPath & "/semfoto.jpg")
        End If
    End Sub
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        CarregaDados()
    End Sub
    Private Sub CarregaDados()
        Try
            dgvAlunos.DataSource = acc.carregaDados()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Private Sub dgvAlunos_CellClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvAlunos.CellClick
        Try
            Dim codigo As Integer = dgvAlunos.Rows(e.RowIndex).Cells(0).Value()
            Procurar(codigo)
        Catch ex As Exception
            MsgBox("Seleção Inválida. Clique em uma célula com dados.")
        End Try
    End Sub
    Private Sub btnLimpar_Click(sender As System.Object, e As System.EventArgs) Handles btnLimpar.Click
        Me.txtCodigo.Text = ""
        Me.txtNome.Text = ""
        Me.picFoto.Image = Nothing
        Me.txtCodigo.Focus()
        Me.btnIncluir.Enabled = True
    End Sub
    Private Sub txtNome_Validating(sender As System.Object, e As System.ComponentModel.CancelEventArgs) Handles txtNome.Validating
        If (txtNome.Text.Trim().Length = 0) Then
            erro.SetError(txtNome, "Informe o nome do aluno")
        Else
            erro.SetError(txtNome, "")
        End If
    End Sub
    Private Sub btnDeletar_Click(sender As System.Object, e As System.EventArgs) Handles btnDeletar.Click

        Dim resultado As DialogResult = MessageBox.Show("Confirma a exclusão deste registro ?", _
            "Excluir", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
        If resultado = vbYes Then
            Dim codigo As Integer
            If txtCodigo.Text = String.Empty Then
                MsgBox("Informe o codigo do aluno")
                txtNome.Focus()
                Return
            Else
                codigo = Convert.ToInt32(txtCodigo.Text)
            End If

            Try
                acc.deletarRegistro(codigo)
                MsgBox("Dados excluídos com sucesso!")
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
            CarregaDados()
        End If
    End Sub
    Private Sub btnAlterar_Click(sender As System.Object, e As System.EventArgs) Handles btnAlterar.Click
        Dim arrImage() As Byte
        Dim strImage As String
        Dim myMs As New IO.MemoryStream

        If txtNome.Text = String.Empty Then
            MsgBox("Informe o nome do aluno")
            txtNome.Focus()
            Return
        End If
        If Not IsNothing(Me.picFoto.Image) Then
            Me.picFoto.Image.Save(myMs, Me.picFoto.Image.RawFormat)
            arrImage = myMs.GetBuffer
            strImage = "?"
        Else
            arrImage = Nothing
            strImage = "NULL"
        End If
        Try
            acc.atualizarDados(txtNome.Text, strImage, txtCodigo.Text, arrImage)
            MsgBox("Dados Alterados com sucesso!")
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        CarregaDados()
    End Sub
End Class
